<?php
// --------------------------------------------------------
// parse a html page to retrieve main tags
//
// version: 0.2
// date:    2003.06.22
// author:  erational <http://wwww.erational.org>
// --------------------------------------------------------

if (!isset($uri)) $uri = "http://www.erational.org/";
   			else  $uri = "http://$uri"; 
             
// check if string contains XML forbidden characters
function convertXML($str) {
    $find = preg_match_all("|([<>&])|",$str,$match);	
    if (!$find)  return $str;
		 else   return "<![CDATA[$str]]>";
}

// header:  xml and no cache
header("Content-type: application/xml");		
header("Expires: Mon, 5 Jan 1977 05:00:00 GMT");              
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");   
header("Cache-Control: no-cache, must-revalidate");           // HTTP/1.1  
header("Pragma: no-cache");                                   // HTTP/1.0


echo "<?xml version=\"1.0\"?><flexplorer>\n";

$myfile = @file($uri);
if ($myfile) {
	$str = implode("",$myfile);  
    $find = preg_match_all("|<title>?([^<]+)|i",$str,$match);
    if ($find) echo "<title>". convertXML($match[1][0])."</title>";	
	$find = preg_match_all('|href="([^\'" >]+)?([^>]+)>?([^<]+)</a>|i',$str,$match);
	if($find){
		for($i=0;$i<count($match[0]);$i++)
		    echo "<a href=\"".$match[1][$i]."\">".convertXML($match[3][$i])."</a>";
	}
	echo "<uri>".convertXML($uri)."</uri>";
} else { 
  echo "<error>can't fetch uri: ".convertXML($uri)." ????</error>";
}
echo "</flexplorer>";
?>